"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var refnew_1 = require("refnew");
var shallowequal_1 = tslib_1.__importDefault(require("shallowequal"));
function create() {
    /**
     * Map for calculates bitmask.
     */
    var selects = new Map();
    /**
     * React Context.
     */
    var _a = react_1.default.createContext({}, function (_, next) {
        var bits = Array.from(selects.entries()).reduce(function (bits, _a) {
            var select = _a[0], _b = _a[1], bit = _b.bit, prev = _b.prev;
            if (!shallowequal_1.default(select(next), prev)) {
                return bits | bit;
            }
            return bits;
        }, 0);
        return bits;
    }), Provider = _a.Provider, Consumer = _a.Consumer;
    /**
     * RefnewProvider.
     */
    var RefnewProvider = /** @class */ (function (_super) {
        tslib_1.__extends(RefnewProvider, _super);
        function RefnewProvider(props) {
            var _this = _super.call(this, props) || this;
            _this.state = {
                version: 0,
                value: refnew_1.refnew({
                    state: props.value
                })
            };
            return _this;
        }
        RefnewProvider.prototype.componentDidMount = function () {
            var _this = this;
            updator = function (mutator) {
                mutator && mutator(_this.props.value);
                _this.setState({
                    version: _this.state.version + 1
                });
            };
        };
        RefnewProvider.prototype.componentWillUnmount = function () {
            updator = function (_) { };
        };
        RefnewProvider.prototype.render = function () {
            var children = this.props.children;
            return react_1.default.createElement(Provider, { value: this.state.value.state }, children);
        };
        return RefnewProvider;
    }(react_1.default.Component));
    /**
     * RefnewConsumer.
     */
    var RefnewConsumer = /** @class */ (function (_super) {
        tslib_1.__extends(RefnewConsumer, _super);
        function RefnewConsumer() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.state = { bit: 0 };
            return _this;
        }
        RefnewConsumer.getDerivedStateFromProps = function (props) {
            if (!selects.has(props.select)) {
                selects.set(props.select, { bit: 1 << selects.size });
            }
            return { bit: selects.get(props.select).bit };
        };
        RefnewConsumer.prototype.shouldComponentUpdate = function () {
            return false;
        };
        RefnewConsumer.prototype.render = function () {
            var _this = this;
            return (react_1.default.createElement(Consumer, { unstable_observedBits: this.state.bit }, function (state) { return _this.select(state); }));
        };
        RefnewConsumer.prototype.select = function (state) {
            var _a = this.props, children = _a.children, select = _a.select;
            return children((selects.get(select).prev = select(state)));
        };
        return RefnewConsumer;
    }(react_1.default.Component));
    var updator;
    return {
        Provider: RefnewProvider,
        Consumer: RefnewConsumer,
        update: function (mutator) {
            updator && updator(mutator);
        }
    };
}
exports.create = create;
//# sourceMappingURL=index.js.map