/// <reference types="react" />
export declare type ProviderProps<State> = {
    value: State;
    children: JSX.Element | JSX.Element[];
};
export declare type ConsumerProps<State, SelectedState> = {
    select: (s: State) => SelectedState;
    children: (s: SelectedState) => JSX.Element | JSX.Element[];
};
export declare function create<State extends object>(): {
    Provider: (props: ProviderProps<State>) => JSX.Element;
    Consumer: <SelectedState>(props: ConsumerProps<State, SelectedState>) => JSX.Element;
    update: (mutator?: (state: State) => void) => void;
};
